import sys
from mapreducelocal import *

def fun_map_1(e,params):
    delimiter=params['delimiter']    
    count_map={}    
    for row in e.split('\n'):
        transactions=row.split(delimiter)
        for i in range (0,len(transactions)):
	      if transactions[i]=='1':
	          count_map[str(i)]=1  
    return [ (i,count) for i,count in count_map.iteritems()]

def fun_reduce_1(iter, out, params):
    min_support=params['min_support']
    count_dict = {}
    for i, count in iter:
        if i not in count_dict: 
            count_dict[i]=int(count)
        else:
            count_dict[i]+=int(count)        
		
    for i, total in count_dict.iteritems():
        if total > min_support:
	      out.add(i, total)

print "Starting Disco job 1.."
parameters={}
parameters['delimiter']=','
parameters['min_support']=5
job=MapReduceJob("marketbasket.csv",
                parameters,
		    fun_map_1,                
		    fun_reduce_1)

results = job.execute()

print "Job 1 done. Results:"
for i, count in result_iterator(results):
    print i, count


#put your code for 2-item candidate itemset generation
#put resulting 2-item pairs as keys of the dictionary candidates_2
candidates_2={}

parameters['pairs']=candidates_2

#implement fun_map_2
def fun_map_2(e,params):
    candidates=parameters['pairs']
    #for each line of the input determine if it contains any of candidate pair 

#implement fun_reduce_2
def fun_reduce_2(iter, out, params):
    min_support=params['min_support']
    #add up counts for each pair
    # add to result set only if count >=min_support

#run job 2
print "Starting Disco job 2.."
#job=MapReduceJob("marketbasket.csv",
#                parameters,
#		    fun_map_2,                
#		    fun_reduce_2)

#results = job.execute()

print "Job 2 done. Results:"
#for pair, count in result_iterator(results):
#    print pair, count



